//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998,1999, All Rights Reserved.
//
//--------------------------------------------------------------------------


#ifndef CONSTANT_H
#define CONSTANT_H

//#define TRAKER_SIGN "application/x-vnd.Be-TRAK"
#define TRACKER_SIGN "application/x-vnd.Be-TRAK"
#define BEMAIL_SIGN "application/x-vnd.Be-MAIL"
#define NETPOSITIVE_SIGN "application/x-vnd.Be-NPOS"
#define DESKBAR_SIGN "application/x-vnd.Be-TSKB"

#define MY_APP_VENDOR "KMSF"

enum {
	K_UNIVERSAL_CONSTANT='kMsf',
	// --------
	K_SELECT='kSlc',
	K_OPEN='kOpn',
	K_CLOSE='kCls',
	K_SET='kSet',
	K_NEW='kNew',
	// --------
	K_ADD='kAdd',
	K_REMOVE='kDel',
	K_INVOKE='kInv',
	K_UPDATE='kUpd',
	// --------
	K_ACTION='kAct',
	K_SET_PREF='kPrf',
	K_SAVE_PREFS='kSPf',
	// --------
	K_OPEN_MAIL='kMeL',
	K_OPEN_WEB='kWeB',
	// --------
	K_COMMIT='kOKx',
	K_CANCEL='kCnl',
	K_REVERT='kRvt',
	// --------
	K_END_UNIVERS='kXXX'
};

enum {
	K_SHOW_PARENT=1,
	K_HIDE_ENTRIES=2,
	K_RESOLVE_SYMLINK=4,
	K_EXPLORE_SUB_FOLDERS=8
};

enum action_type {
	K_ACTION_NOP,
	K_ACTION_MOVE,
	K_ACTION_COPY,
	K_ACTION_LIST,
	K_ACTION_LAUNCH,
	K_ACTION_SEND,
	K_ACTION_INSTANCIATE,
	K_ACTION_SAVE,
	K_ACTION_SAVE_AS,
	K_ACTION_DRAG,
	K_ACTION_NEW,
	K_ACTION_SET,
	K_ACTION_GO_FORWARD,
	K_ACTION_GO_BACKWARD
	//....
};

enum widget_state {
	K_AWAITING=0,
	K_NO_TRACKING=0,
	K_BEGIN_RECT_TRACKING,
	K_DRAGGING,
	K_BEGIN_SELECTING,
	K_MOUSE_DOWN,
	K_MOUSE_OVER
};

#endif