//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998,1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef TEXT_CONTROL_H
#define TEXT_CONTROL_H

#include "InterfaceKit.h"

class KTextControl : public BTextControl {
public:
	KTextControl(BRect frame, const char *name, 
         const char *label, const char *text, 
         float divider,
         BMessage *message, 
         uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP, 
         uint32 flags = B_WILL_DRAW | B_NAVIGABLE);
         
  	virtual void ResizeToPreferred(void);
};
      
#endif