/*
	
	
	
*/

#include <stdio.h>
#include <alloc.h>

#include <StorageKit.h>

#include "constant.h"

#include "me_window.h"
#include "me_app.h"

#include "wMessageBuilder.h"

#include "define.h"

MEApp *ME_app;

main()
{	
	MEApp myApplication;
	ME_app=&myApplication;
	myApplication.Run();
	return(0);
}

class wSpecialLooper : public BLooper {
public:
	wSpecialLooper():BLooper()
	{
		Run();
	}
	
	void DispatchMessage(BMessage *message, BHandler *target)
	{
		if (message->IsReply()) {
			ME_app->OpenMessage("Replying Message",ME_app->GetNewIndex(),message);
		} else if (message->WasDropped()) {
			ME_app->OpenMessage("Dropped Message",ME_app->GetNewIndex(),message);
		} else if (message->IsSourceRemote()) {
			ME_app->OpenMessage("Incoming Message",ME_app->GetNewIndex(),message);
		} else {
			ME_app->OpenMessage("Some Message",ME_app->GetNewIndex(),message);
		}
	}
	
	
	// catch all scriptable messages
	BHandler *ResolveSpecifier(BMessage *message, int32 index, BMessage *specifier, int32 what, const char *property)
	{
		return this;
	}

};

MEApp::MEApp()
		  		  : wApplication(MY_APP_SIGN)
{
	fLooper=new wSpecialLooper();
	fOpenPanel=NULL;
	//fCount=0;
	fFrame=BRect(100,100,110,110);

	//fSlave=false;
}

void MEApp::ReadyToRun(void)
{
	if (CountWindows()==0) {
		MEWindow	*aWindow = new MEWindow(BRect(100,100,300,300));
		aWindow->Show();
	} //else
		//fSlave=true;
}

void MEApp::MessageReceived(BMessage *msg)
{
	switch (msg->what) {
		case K_NEW:{
			BMessage test;
			if (msg->FindBool("test")) {
				test.what=B_SIMPLE_DATA;
				test.AddString("essai","xxx");
				test.AddInt32("essai",123);// error
				test.AddString("essai","zzz");
				test.AddString("essai2","yyy");
				test.AddString("essai2","zzz");
				test.AddSpecifier("pipo");
				test.AddSpecifier("bimbo","zebi");
				test.AddSpecifier("popo",3);
				OpenMessage("Test Message",GetNewIndex(),&test,BMessenger(fLooper));
			} else {
				OpenMessage("Empty Message",GetNewIndex(),&test,BMessenger(fLooper));
			}
			break;}
		case B_SIMPLE_DATA:{
			BMessage	message;
			BMessenger	messenger;
			if (msg->FindMessage("message",&message)==B_OK)
				if (msg->FindMessenger("messenger",&messenger)==B_OK)
					OpenMessage("B_SIMPLE_DATA Message",GetNewIndex(),&message,messenger);
				else
					OpenMessage("B_SIMPLE_DATA Message",GetNewIndex(),&message,BMessenger(fLooper));
			break;}
		case K_OPEN:
			if (fOpenPanel==NULL) {
				fOpenPanel=new BFilePanel (
					B_OPEN_PANEL,&be_app_messenger, NULL, 0, false,
					new BMessage(B_REFS_RECEIVED), NULL, false, true);
			};
			fOpenPanel->Show();
			break;
		/*
		case K_CLOSE_ITEM:
			fCount--;
			if (fSlave&&fCount<1)
				Quit();
			break;
		*/
		default:
			wApplication::MessageReceived(msg);
	}
}

void MEApp::AboutRequested()
{
	(new BAlert(
			"About "MY_APP_NAME,
			MY_APP_NAME" "MY_APP_REVISION_VERSION" - "MY_APP_REVISION_DATE"\n\n     \""MY_APP_COMMENT"\"\n\n          -- by "MY_APP_AUTHOR_NAME"\n\nemail:"MY_APP_AUTHOR_EMAIL"\n"MY_APP_AUTHOR_WEB,
			"OK"))->Go(NULL);
}

void MEApp::RefsReceived(BMessage *msg)
{
	entry_ref ref;
	int32 index=0;
	while (msg->FindRef("refs",index++,&ref)==B_OK) {
		OpenMessage(&ref);
/*
		BFile refile (&ref, B_READ_ONLY);
		BNodeInfo noddy (&refile);
		char buf[256];
		status_t st = noddy.GetType(buf);
		BMessage unflatten;
		unflatten.Unflatten(&refile);
		OpenMessage(ref.name,0,&unflatten);
*/
	}
}

void MEApp::OpenMessage(entry_ref *ref)
{
	fFrame.OffsetBy(18,18);
	(new wMessageBuilder(fFrame,ref,fLooper))->Show();
}

void MEApp::OpenMessage(const char *title,int32 index,BMessage *msg)
{
	BMessenger messenger=msg->ReturnAddress();
	OpenMessage(title,index,msg,messenger);
}

void MEApp::OpenMessage(const char *title,int32 index,BMessage *msg,BMessenger messenger)
{
	BString extitle(title);
	if (index>0) {
		extitle<<" ";
		extitle<<index;
	}
	fFrame.OffsetBy(18,18);
	(new wMessageBuilder(fFrame,extitle.String(),msg,messenger,fLooper))->Show();
}
