//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef APP_KMSF
#define APP_KMSF

#include <AppKit.h>
#include <InterfaceKit.h>
#include "tips.h"

//extern KTipsManager *tips;

class wApplication : public BApplication {
public:
	wApplication(const char *signature);
	~wApplication();
	
	virtual void MessageReceived(BMessage *message);
	
	int32 GetNewIndex();
	
	virtual bool QuitRequested(void);
	
private:
	int32	fCountDocumentWindow,fDocumentWindowIndex;
};

class wDocumentWindow : public BWindow {
public:
	wDocumentWindow(BRect frame,
			const char *title,
			window_type type,
			uint32 flags,
			uint32 workspace = B_CURRENT_WORKSPACE);
	wDocumentWindow(BRect frame,
			const char *title,
			window_look look,
			window_feel feel,
			uint32 flags,
			uint32 workspace = B_CURRENT_WORKSPACE);
			
	void Init();
	
	//virtual bool QuitRequested(void);
	virtual void Quit();
};

#endif
