//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef COMMAND_EDITOR_KMSF
#define COMMAND_EDITOR_KMSF

#include <InterfaceKit.h>

#include "pack_view.h"
#include "wDBObjects.h"

class wCommandEditor : public KPackView {
public:
	wCommandEditor(BRect frame,const char *name,
		 //bool propagate,
         uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP, 
         uint32 flags = B_WILL_DRAW | B_FRAME_EVENTS | B_NAVIGABLE_JUMP, 
         border_style border = B_FANCY_BORDER);
 	
 	virtual void BuildCommandMenu(BMenu *menu);
 	virtual void AttachedToWindow();
 	virtual void MessageReceived(BMessage *msg);
 	
 	void SetCommand(int32 command);
 	//int32 GetCommand();
 	void MimicMessage(BMessage *msg);
 	
private:
	typedef KPackView inherited;
	
	int32	fCommand;
	BMenu	*fCommandMenu;
	BTextControl	*fCommandWhatCode;
};

#endif
