//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef MESSAGE_UTILS_KMSF
#define MESSAGE_UTILS_KMSF

#include <InterfaceKit.h>

extern int32 data_type_table[];
extern int32 specifier_table[];

void
seewhat (
	uint32 in,
	char *out	// must be 9 chars at least
);

const char *name_of_specifier(int32 specifier) ;
const char *name_of_command(int32 command);

void sprint_data(char *buf,int32 type,BMessage *hmsg,const char *name,int32 j);

const char *name_of_data_type(type_code typeCode);

BMenuItem *new_command_item(int32 command) ;

#endif