//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998,1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

#include "text_control.h"

KTextControl::KTextControl(BRect frame, const char *name, 
         const char *label, const char *text, 
         float divider,
         BMessage *message, 
         uint32 resizingMode,
         uint32 flags):
BTextControl(frame,name,label,text,message,resizingMode,flags)
{
	SetDivider(divider);
}

void KTextControl::ResizeToPreferred(void)
{
	float width,height,wlabel;
	GetPreferredSize(&width,&height);
	wlabel=StringWidth(Label())+10;
	if (wlabel>Divider()) SetDivider(wlabel);
	ResizeTo(width,height);
}
      