#ifndef ME_APP_H
#define ME_APP_H

#include "wApp.h"

#ifndef _APPLICATION_H
#include <Application.h>
#endif

class MEApp : public wApplication 
{
public:
	MEApp();
	
	virtual void ReadyToRun(void);
	
	virtual void MessageReceived(BMessage *msg);
	virtual void AboutRequested();
	virtual void RefsReceived(BMessage *message);

	void	OpenMessage(entry_ref *ref);
	void 	OpenMessage(const char *title,int32 index,BMessage *msg);
	void 	OpenMessage(const char *title,int32 index,BMessage *msg,BMessenger);
	
private:
	//int32	fCount;
	BRect	fFrame;
	BLooper *fLooper;
	BFilePanel	*fOpenPanel;
	
	//bool	fSlave;
};

extern MEApp *ME_app;

#endif
