#include "me_app.h"

#include "me_window.h"

#include "constant.h"
#include "wMessageBuilder.h"

MEWindow::MEWindow(BRect frame)
				: wDocumentWindow(frame, "Drop Message On Me !", B_TITLED_WINDOW, B_NOT_ZOOMABLE )
{
	// set up a rectangle and instantiate a new view
	//BMessage *test;
	//AddChild(new BButton(BRect(0,0,50,50),"b_test","test",test=new BMessage(K_TEST_ITEM)));
	// ----
	BMenuBar *mb=new BMenuBar(BRect(0,0,50,20),"_menu_bar_");
	BMenu *m=new BMenu("File");
	BMessage *invoke;
	m->AddItem(new BMenuItem("New empty message",invoke=new BMessage(K_NEW),'N'));
	invoke->AddBool("test",false);
	m->AddItem(new BMenuItem("New test message",new BMessage(K_NEW),'T'));
	invoke->AddBool("test",true);
	m->AddItem(new BMenuItem("Open message…",new BMessage(K_OPEN),'O'));
	m->AddItem(new BSeparatorItem());
	m->AddItem(new BMenuItem("About",new BMessage(B_ABOUT_REQUESTED)));
	m->AddItem(new BSeparatorItem());
	m->AddItem(new BMenuItem("Quit",new BMessage(B_QUIT_REQUESTED),'Q'));
	m->SetTargetForItems(be_app);
	mb->AddItem(m);
	AddChild(mb);
}

bool MEWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED,be_app);
	return(true);
}

void MEWindow::MessageReceived(BMessage *msg)
{
	if (msg->WasDropped()) {
		ME_app->OpenMessage("B_SIMPLE_DATA Message",ME_app->GetNewIndex(),msg);
	} else {
		wDocumentWindow::MessageReceived(msg);
	}
}

// catch scriptable messages
BHandler *MEWindow::ResolveSpecifier(BMessage *message, int32 index, BMessage *specifier, int32 what, const char *property)
{
	return this;
}