//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@mad.unice.fr
//
//		Copyright 1998, All Rights Reserved.
//
//--------------------------------------------------------------------------

#ifndef INFO_VIEWER_KMSF
#define INFO_VIEWER_KMSF

#include "pack_view.h"
#include "tab_view.h"

class wMessageInfoViewer : public KPackView {
public:
	wMessageInfoViewer(BRect frame, const char *name, 
		//bool propagate=true,
		uint32 resizingMode=B_FOLLOW_ALL_SIDES, 
		uint32 flags=0);
 	virtual void AttachedToWindow(bool first_time);
 	
 	void SetMessage(BMessage *msg);

private:
	typedef KPackView inherited;
	
	BCheckBox	*fIsSystem,
				*fWasDelivered,
				*fIsSourceRemote,
				*fIsSourceWaiting,
				*fIsReply,
				*fWasDropped;
};

#endif