#ifndef SFX_MENU_H
#define SFX_MENU_H

#include <InterfaceKit.h>

class SFXSeparatorItem : public BSeparatorItem
{
public:
	SFXSeparatorItem();
	
	virtual void Draw();
};

class SFXPopUpMenu : public BPopUpMenu
{
public:
	SFXPopUpMenu(const char *name, bool radioMode = true, 
         bool labelFromMarked = true, 
         menu_layout layout = B_ITEMS_IN_COLUMN);
    ~SFXPopUpMenu();
    
    bool AddSeparatorItem();
         
    virtual void AttachedToWindow();
    virtual void DetachedFromWindow();
    
  	virtual void DrawBackground(BRect update);
  	virtual void Draw(BRect updateRect);

private:
	typedef BPopUpMenu inherited;
	
	BBitmap *fBackground;
};

#endif